--[[
SIMPLE ACHIEVEMENT TRACKER FOR TITAN PANEL

Plug-in for Titan Panel to display your tracked achievements.

Maintained by: John McAllister (jandd661)
Author: John McAllister (jandd661)

NOTE: There are many things I don't like about the code here so I will be
cleaning it up in future releases.

Copyright 2016 - 2017 John McAllister
--------------------------------------------------------------------------
This file is part of Titan Simple Achievement Tracker.

Titan Simple Achievement Tracker is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Titan Simple Achievement Tracker is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License (Licence.txt)
along with Titan Simple Achievement Tracker.  If not, see <http://www.gnu.org/licenses/>.

You can contact jand661 by PM at CurseForge.com
--------------------------------------------------------------------------
]]--
local TSAT_LuaVersion = "r002"
local TSAT_JD661_UTILS_VERSION_REQ = "r002"
local TSAT_AddonName = "TitanSimpleAchievementTracker"
local TSAT_IconPath = "Interface\\Icons\\achievement_guildperk_mrpopularity_rank2.blp"
local TSAT_MenuText = "Simple Achievement Tracker "
local TSAT_ButtonLabel = ""
local TSAT_ToolTipTitle = "Tracked Achievements"
local TSAT_ID = "TSAT"
local strRightClickHideMenuText = "Hide Simple Achievement Tracker"
local strErrorNoName = JD661Utils_ColorText("** Not returned by server **", "red")

local strRightClickHideSubToggle = "|- Show sub-achievements "
local strRightClickHideCompletedSubToggle = "|- Show completed sub-achievements"

local strRightClickHideSubSubToggle = "|-- Show sub-sub-achievements "
local strRightClickHideCompletedSubSubToggle = "|-- Show completed sub-sub-achievements"	

local strRightClickToolTipUseSmallFont = "Use smaller font size"

local TSAT_textForTooltip
local TSAT_text = "Achievement Points: "
local i = 0

SLASH_TSAT1 = "/tsat"

------------------------------------------------------
 -- Only update the button every n cycles of self:SetScript("OnUpdate", TSAT_Main)
 -- 10 cycles seems to be about a second.
------------------------------------------------------
local intUpdateOnCycle = 10
------------------------------------------------------
-- Set intDisplayDebugInfo to 1 
-- for some debug info in the tool tip text
-- assuming it makes it that far lol.
-- Not very useful at the moment
------------------------------------------------------
strDebugInfo = ""
intDisplayDebugInfo = 0
--------------------------------------------------------------
-- Tooltip scaling hooked ownership check borrowed from papsol and slightly modified
--------------------------------------------------------------
function TSAT_TooltipHook()
	local TSAT_OldScale
	local TSAT_isTooltipShowing = false
	if GameTooltip:GetOwner() == TitanPanelTSATButton then
		if(TitanGetVar(TSAT_ID, "UseSmallFont") ~= false)then
			if GameTooltip:GetOwner() == TitanPanelTSATButton then 
				if not TSAT_isTooltipShowing then
					TSAT_isTooltipShowing = true
					TSAT_OldScale = GameTooltip:GetScale()
					GameTooltip:SetScale(TitanGetVar(TSAT_ID, "ToolTipScale"))
				end
			elseif TSAT_isTooltipShowing  then
				TSAT_isTooltipShowing = false
				if TSAT_OldScale then
					GameTooltip:SetScale(TSAT_OldScale)
					TSAT_OldScale = nil
				end
			end
		else
			GameTooltip:SetScale(1)
		end
	else
		GameTooltip:SetScale(1)
	end
	--print("TSAT_isTooltipShowing=" .. tostring(TSAT_isTooltipShowing))
	--print("TSAT_OldScale=" .. tostring(TSAT_OldScale))
	--print(GameTooltip:GetScale())
	--GameTooltip:SetScale(1)
end
--------------------------------------------------------------
-- EVENT Handler
--------------------------------------------------------------
function TSAT_OnEvent(self, event, ...)
	--UI_SCALE_CHANGED
	--print(tostring(event))
end
--------------------------------------------------------------
-- Slash Handler
--------------------------------------------------------------
function TSAT_HandleSlash(msg, editbox)
	if msg == "reset" then
		TitanSetVar(TSAT_ID, "ToolTipScale", .8)
		TitanSetVar(TSAT_ID, "ShowIcon", 1)
		TitanSetVar(TSAT_ID, "ShowLabelText", false)
		TitanSetVar(TSAT_ID, "ShowSub", true)
		TitanSetVar(TSAT_ID, "ShowCompletedSub", true)
		TitanSetVar(TSAT_ID, "ShowSubSub", true)
		TitanSetVar(TSAT_ID, "ShowCompletedSubSub", true)
		TitanSetVar(TSAT_ID, "UseSmallFont", false)
		print("TSAT settings rest to:")
		TSAT_PrintSettings()
	elseif msg == "settings" then
		print("TSAT Settings:")
		TSAT_PrintSettings()
	end
		
end
--------------------------------------------------------------
-- Print the current settings
--------------------------------------------------------------
function TSAT_PrintSettings()
	print("ToolTipScale = " .. tostring(TitanGetVar(TSAT_ID, "ToolTipScale")))
	print("ShowIcon = " .. tostring(TitanGetVar(TSAT_ID, "ShowIcon")))
	print("ShowLabelText = " .. tostring(TitanGetVar(TSAT_ID, "ShowLabelText")))
	print("ShowSub = " .. tostring(TitanGetVar(TSAT_ID, "ShowSub")) .. "\n")
	print("ShowCompletedSub = " .. tostring(TitanGetVar(TSAT_ID, "ShowCompletedSub")))
	print("ShowSubSub = " .. tostring(TitanGetVar(TSAT_ID, "ShowSubSub")) .. "\n")
	print("ShowCompletedSubSub = " .. tostring(TitanGetVar(TSAT_ID, "ShowCompletedSubSub")))
	print("UseSmallFont = " .. tostring(TitanGetVar(TSAT_ID, "UseSmallFont")))
end
--------------------------------------------------------------
-- OnLoad Make the button
--------------------------------------------------------------
function TSAT_OnLoad(self)
	local strTocVersion = GetAddOnMetadata(TSAT_AddonName, "X-Version")
	local strLuaVersion = TSAT_LuaVersion
	if(TSAT_JD661_UTILS_VERSION_REQ ~= JD661_UTILS_VERSION) then
		print("TitanSimpleAchievementTracker: Utils version: " .. JD661_UTILS_VERSION .. " not matching Lua required version: " .. TSAT_JD661_UTILS_VERSION_REQ ..". This addon may not work correctly")	
	end
	if(strTocVersion ~= strLuaVersion) then
		print("TitanSimpleAchievementTracker: Toc version: " .. strTocVersion .. " not matching Lua version: " .. strLuaVersion ..". This addon may not work correctly")
	end
	self.registry = {
		id = TSAT_ID,
		menuText = TSAT_MenuText .. JD661Utils_ColorText(" (" .. strTocVersion .. ")","green"),
		buttonTextFunction = "TitanPanelTSATButton_GetButtonText",
		tooltipTitle = TSAT_ToolTipTitle,
		tooltipTextFunction = "TitanPanelTSATButton_GetTooltipText",
		frequency = 1,
		icon = TSAT_IconPath,
		iconWidth = 16,
		category = "Information",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = false,
			ShowSub = true,
			ShowCompletedSub = true,
			ShowSubSub = true,
			ShowCompletedSubSub = true,
			UseSmallFont = false,
			ToolTipScale = .8,
			
		},
	}
	self:RegisterEvent("UI_SCALE_CHANGED");
	hooksecurefunc(GameTooltip, "Show", TSAT_TooltipHook)	
end
--------------------------------------------------------------
-- The guts
--------------------------------------------------------------
function GetAchList()
	local ach = { GetTrackedAchievements() }
	local countAchTracked = GetNumTrackedAchievements()
	local List = {}
	local numCrit = 0
	local outText = ""	
	
	if(countAchTracked > 0) then
		for _, id in ipairs (ach) do
			local DisplayThisRecord = true
			local achID, achName, achPoints, achComplete, achMonth, achDay, achYear, achDesc, achFlags, achIcon, achRewardText, achIsGuildAch, achWasEarnedByMe, achEarnedBy = GetAchievementInfo(id)
			numCrit = 0
			
			-- If the Achievement is compete and TitanGetVar(TSAT_ID, ShowCompleted) == false, skip this one
			if((achComplete == true and TitanGetVar(TSAT_ID, "ShowCompleted") ~= false) or (achComplete == false)) then
				DisplayThisRecord = true
			else
				DisplayThisRecord = false
			end
			
			if(achID and DisplayThisRecord == true) then
				local strDesc = ""
				if(achDesc ~= "") then
					strDesc = achDesc .. "\n"
				end
				outText = outText .. "===========\n"
				if(achComplete == true) then
					outText = outText .. JD661Utils_ColorText(achName,"green")
				else
					outText = outText .. JD661Utils_ColorText(achName, "white")
				end
				if(achIsGuildAch == true) then
					outText = outText .. JD661Utils_ColorText(" (G)", "lightblue") .. "\n" .. strDesc
				else
				 outText = outText .. "\n" .. strDesc
				end
				------------------- SUBs ---------------------------
				numCrit = GetAchievementNumCriteria(id)
				if(TitanGetVar(TSAT_ID, "ShowSub") ~= false) then
					for i = 1, numCrit do 
						local qtyString = ""
						local DisplaySubRecord = true
						local description, atype, completed, quantity, requiredQuantity, characterName, flags, assetID, quantityString, criteriaID = GetAchievementCriteriaInfo(achID, i)
						if(string.len(quantityString) > 1) then
							qtyString = JD661Utils_ColorText(quantityString, "white")
						end
						local descString = ""
						if(description ~= "") then
							descString = description
						else
							if(qtyString ~= "") then
								descString = "Count: "
							else
								descString = strErrorNoName
							end
						end
						if(completed == true) then
							if(TitanGetVar(TSAT_ID, "ShowCompletedSub") ~= false) then
								outText = outText .. "   |- " .. JD661Utils_ColorText(descString,"green") .. " " .. qtyString .. "\n"
							end
						else 
							outText = outText .. "   |- " .. descString .. " " .. qtyString .. "\n"
						end
						----------- SUB SUB Quests ----------------------
						if(DisplaySubRecord == true) then
							if(atype == 8) then -- 8 is a quest
								if(TitanGetVar(TSAT_ID, "ShowSubSub") ~= false) then
									local xachID, xachName, xachPoints, xachComplete, xachMonth, xachDay, xachYear, xachDesc = GetAchievementInfo(assetID)
									if(xachID) then
										local xnumCrit = GetAchievementNumCriteria(assetID)
										for xi = 1, xnumCrit do
											local xdescription, xatype, xcompleted, xquantity, xrequiredQuantity, xcharacterName, xflags, xassetID, xquantityString, xcriteriaID = GetAchievementCriteriaInfo(assetID, xi)
											local xqtyString = ""
											if(xquantityString ~= "" and xquantityString ~= "0" and xquantityString ~= "1") then
												xqtyString = JD661Utils_ColorText(xquantityString,"white")
											end
											if(xcompleted == true) then
												if(TitanGetVar(TSAT_ID, "ShowCompletedSubSub") ~= false) then
													if(TitanGetVar(TSAT_ID, "ShowCompletedSub") ~= false) then
														outText = outText .. "      |--" .. " " .. JD661Utils_ColorText(xdescription,"green") .. " " .. xqtyString .. "\n"
													end
												end
											else
												if(TitanGetVar(TSAT_ID, "ShowSubSub") ~= false) then
													outText = outText .. "      |--" .. " " .. xdescription .. " " .. xqtyString .. "\n"
												end
											end
										end
									end
								end
							end
						end
						------------- END SUB SUB Quests ---------------
					end
				end
				---------------- END SUBS --------------------------
			end
		end
	else
		outText = "Not tracking achievements!"
	end
	return outText
end
-------------------------------------------
-- Used to meter the auto update of the button from
-- self:SetScript("OnUpdate", TSAT_Main)
-- There is no need to start a bunch of math
-- and UI calls every millisecond. 
-------------------------------------------
function TSAT_Update()
	--print(i)
	if(i > intUpdateOnCycle) then
		TSAT_Main()
		i = 0
	else
		i = i + 1
	end
end

--------------------------------------------------------------
-- Traffic control for later
--------------------------------------------------------------
function TSAT_Main()
	TitanPanelButton_UpdateButton(TSAT_ID)
end
----------------------------------------------
-- Create the text for the Titan Bar button
----------------------------------------------
function TitanPanelTSATButton_GetButtonText()
	-- Expand this later to show guild info
	TSAT_ButtonLabel = tostring(GetTotalAchievementPoints(false))
	return TSAT_text, TSAT_ButtonLabel
end
-----------------------------------------------
-- Set the tooltip text
-----------------------------------------------
function TitanPanelTSATButton_GetTooltipText()
	return GetAchList()
end
--------------------------------------------------------------
-- Save for later
--------------------------------------------------------------
function SlashCmdList.TSAT(msg, editbox)
	TSAT_HandleSlash(msg, editbox)
end

--------------------------------------------------------------
-- Handle the LeftButton
--------------------------------------------------------------
function TitanPanelTSATButton_OnClick(self, button)
	if (button == "LeftButton") then
		ToggleAchievementFrame()
	end
end
--------------------------------------------------------------
-- Save for later when adding guild achievements
--------------------------------------------------------------
function TSATToggleFrame()
	
end
----------------------------------------------------
-- What to do with a right-click on the button
----------------------------------------------------
function TitanPanelRightClickMenu_PrepareTSATMenu()	
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TSAT_ID].menuText)
	TitanPanelRightClickMenu_AddToggleIcon(TSAT_ID)
	TitanPanelRightClickMenu_AddToggleLabelText(TSAT_ID)
	TitanPanelRightClickMenu_AddSpacer()	
	TitanPanelRightClickMenu_AddToggleVar(strRightClickHideSubToggle, TSAT_ID, "ShowSub")
	TitanPanelRightClickMenu_AddToggleVar(strRightClickHideCompletedSubToggle, TSAT_ID, "ShowCompletedSub")
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddToggleVar(strRightClickHideSubSubToggle, TSAT_ID, "ShowSubSub")
	TitanPanelRightClickMenu_AddToggleVar(strRightClickHideCompletedSubSubToggle, TSAT_ID, "ShowCompletedSubSub")
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddToggleVar(strRightClickToolTipUseSmallFont, TSAT_ID, "UseSmallFont")
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(strRightClickHideMenuText, TSAT_ID, TITAN_PANEL_MENU_FUNC_HIDE)
end

